/*  Copyright (C) 2008 Joshua Judson Rosen <rozzin@geekspace.com>.

    This program is free software: you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 3 as published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING. If not, see
    <http://www.gnu.org/licenses/> or write to:

        The Free Software Foundation, inc.
        51 Franklin Street, Fifth Floor
        Boston, MA 02110-1301
        USA
*/

#ifndef VISUALID_GRAPHICS_H
#define VISUALID_GRAPHICS_H

struct generator;

typedef struct generator * (generator_fn) (int recursion_level);
typedef void (producer_fn) (struct generator *gen, cairo_t *cr);
typedef struct generator * (mutator_fn) (struct generator *base, double amount);

struct generator {
  producer_fn *produce;
  mutator_fn *mutate;
};

struct generator *generate_child (int recursion_level);

void exec_generator (struct generator *generator, cairo_t *cr);

void visualid_draw (struct generator *gen, cairo_t *cr,
                    double width, double height,
                    double linewidth);

/* void visualid_group ( */
#endif
