/*  Copyright (C) 2008 Joshua Judson Rosen <rozzin@geekspace.com>.

    This program is free software: you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 3 as published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING. If not, see
    <http://www.gnu.org/licenses/> or write to:

        The Free Software Foundation, inc.
        51 Franklin Street, Fifth Floor
        Boston, MA 02110-1301
        USA
*/

#ifndef VSUALID_LINEAR_H

struct line_generator {
  struct generator base;

  double len; /* length of the line */
  int n; /* number of C3 children along the line */

  struct generator *ec1; /* end-child 1 */
  double c1_scale;

  struct generator *ec2; /* end-child 2 */
  double c2_scale;

  struct generator *c3; /* child 3 (along the line) */
  double c3_scale;

  int c3_doublesided; /* bool: child-3 is drawn mirrored on both sides */
  double c3_angle; /* angle of child-3 relative to line normal */

  int c3_taper; /* bool: reduce or increase scale of child-3 along the line */
  int c3_increase; /* bool: increase (rather than decrease) child-3 scale */
};

struct generator *gen_line (int level);

#endif
