/*  Copyright (C) 2008 Joshua Judson Rosen <rozzin@geekspace.com>.

    This program is free software: you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 3 as published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING. If not, see
    <http://www.gnu.org/licenses/> or write to:

        The Free Software Foundation, inc.
        51 Franklin Street, Fifth Floor
        Boston, MA 02110-1301
        USA
*/

#ifndef VISUALID_METASHAPE_H
#define VISUALID_METASHAPE_H

struct shape_generator {
  struct generator base;

  int n; /* number of objects (power) */

  int ncoef; /* number of coefficients used in generation of fourier series */
  double *coefficients;
  double *points;

  int fourier; /* bool: use fourier series (else FFT) */
  double exponent; /* spectral exponent for FFT filtering */

  struct generator *inside_child;
  double ic_scale;

  struct generator *outline_child;
  double oc_scale;

  double max_angle; /* i.e.: whether it's a shape or a curve */
};

struct shape_generator *gen_metashape (int level, double arclen);

#endif
