/*  Copyright (C) 2008 Joshua Judson Rosen <rozzin@geekspace.com>.

    This program is free software: you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 3 as published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING. If not, see
    <http://www.gnu.org/licenses/> or write to:

        The Free Software Foundation, inc.
        51 Franklin Street, Fifth Floor
        Boston, MA 02110-1301
        USA
*/

#ifndef VSUALID_RADIAL_H

struct radial_generator {
  struct generator base;

  int n; /* the number of vertices in the n-gon */

  struct generator *vertex_child; /* markers at the vertices, if they will
                                 be expanded */
  float vc_scale; /* scale-reduction factor for vertex children */

  struct generator *mouth_child; /* markers in the centre, if they will be
                                  expanded */
  float mc_scale; /* scale-reduction factor for the mouth child */
  float mouth_org; /* an offset of the centre child down from the
                      centre of the n-gon */

  struct generator *eye_child; /* places two additional children that
                              might be interpreted as "eyes"? */
  float ec_scale; /* their scale reduction */
  float eye_sep; /* the horizontal separation between these */
  float eye_org; /* the offset of the "eyes" up from the center */

  float angle_cutoff; /* vertex children appear only within this
                         angular range (in radians) from the top of
                         the n-gon */
};

struct generator *gen_radial (int level);

#endif
