/*  Copyright (C) 2008 Joshua Judson Rosen <rozzin@geekspace.com>.

    This program is free software: you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 3 as published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING. If not, see
    <http://www.gnu.org/licenses/> or write to:

        The Free Software Foundation, inc.
        51 Franklin Street, Fifth Floor
        Boston, MA 02110-1301
        USA
*/

#ifndef VSUALID_SPIRAL_H

struct spiral_generator {
  struct generator base;

  int len; /* number of segments in the spiral */
  int aligned; /* boolean: children are aligned on radial spokes */
  double ppr; /* points per revolution (ratio, not necessarily n/1) */

  struct generator *centre_child; /* child at the centre of the spiral */
  double centre_scale; /* scale reduction for the child at centre of spiral */

  struct generator *outer_child; /* child used outside the centre */
  double outer_scale; /* scale reduction for the child at outside of spiral */
};

struct generator *gen_spiral (int level);

#endif
